package usaepay;

import org.junit.Test;
import static org.junit.Assert.*;
import static org.hamcrest.CoreMatchers.*;
import com.google.gson.*;
import usaepay.*;
import java.util.*;


public class customerspostTest {
	@Test public void customerspost() {
		API.setAuthentication("Example_API_Key","Example_Pin");
		API.local_test=true;

		//Building Response
		Map<String, Object> expected_response = new HashMap<String, Object>();
		expected_response.put("type","customer");
		expected_response.put("key","nsds9yd1h5kb9y5h");
		expected_response.put("custid","123456");
		expected_response.put("company","Weasleys Wizard Wheezes");
		expected_response.put("first_name","George");
		expected_response.put("last_name","Weasley");
		expected_response.put("description","Mischief Managed.");
			List<Map> payment_methods = new ArrayList<Map>();
			List<Map> payment_methods1 = new ArrayList<Map>();
			Map<String, Object> CustomerPaymentMethod = new HashMap<String, Object>();
				CustomerPaymentMethod.put("key","x8KccrxeydHJ4MmT");
				CustomerPaymentMethod.put("type","customerpaymentmethod");
				CustomerPaymentMethod.put("method_name","Example method");
				CustomerPaymentMethod.put("cardholder","Testor Jones");
				CustomerPaymentMethod.put("expiration","1221");
				CustomerPaymentMethod.put("ccnum4last","xxxxxxxxxxxxxx7779");
				CustomerPaymentMethod.put("card_type","Visa");
			payment_methods1.add(CustomerPaymentMethod);
			Map<String, Object> CustomerPaymentMethod2 = new HashMap<String, Object>();
				CustomerPaymentMethod2.put("key","x8KccrxeydHJ4MmT");
				CustomerPaymentMethod2.put("type","customerpaymentmethod");
				CustomerPaymentMethod2.put("method_name","Example method");
				CustomerPaymentMethod2.put("cardholder","Testor Jones");
				CustomerPaymentMethod2.put("expiration","1221");
				CustomerPaymentMethod2.put("ccnum4last","xxxxxxxxxxxxxx7779");
				CustomerPaymentMethod2.put("card_type","Visa");
			payment_methods1.add(CustomerPaymentMethod2);
		expected_response.put("payment_methods","payment_methods");
			List<Map> billing_schedules = new ArrayList<Map>();
			List<Map> billing_schedules3 = new ArrayList<Map>();
			Map<String, Object> CustomerSchedule = new HashMap<String, Object>();
				CustomerSchedule.put("type","billingschedule");
					List<Map> rules = new ArrayList<Map>();
					Map<String, Object> CustomerRule = new HashMap<String, Object>();
						CustomerRule.put("type","billingschedulerule");
					rules.add(CustomerRule);
					Map<String, Object> CustomerRule4 = new HashMap<String, Object>();
						CustomerRule4.put("type","billingschedulerule");
					rules.add(CustomerRule4);
				CustomerSchedule.put("rules","rules");
			billing_schedules3.add(CustomerSchedule);
			Map<String, Object> CustomerSchedule5 = new HashMap<String, Object>();
				CustomerSchedule5.put("type","billingschedule");
					List<Map> rules6 = new ArrayList<Map>();
					Map<String, Object> CustomerRule7 = new HashMap<String, Object>();
						CustomerRule7.put("type","billingschedulerule");
					rules.add(CustomerRule7);
					Map<String, Object> CustomerRule8 = new HashMap<String, Object>();
						CustomerRule8.put("type","billingschedulerule");
					rules.add(CustomerRule8);
				CustomerSchedule5.put("rules","rules");
			billing_schedules3.add(CustomerSchedule5);
		expected_response.put("billing_schedules","billing_schedules");
		String encoded_response = API.json_encode(expected_response);
		MockHandler.response = encoded_response;

		//Building Request
		Map<String, Object> reqdata = new HashMap<String, Object>();
			reqdata.put("custid","123456");
			reqdata.put("company","Weasleys Wizard Wheezes");
			reqdata.put("first_name","George");
			reqdata.put("last_name","Weasley");
			reqdata.put("description","Mischief Managed.");
				List<Map> payment_methods9 = new ArrayList<Map>();
				Map<String, Object> CustomerPaymentMethodRequest = new HashMap<String, Object>();
					CustomerPaymentMethodRequest.put("cardholder","Fillius Flitwick");
					CustomerPaymentMethodRequest.put("expiration","1222");
					CustomerPaymentMethodRequest.put("number","4000100011112224");
					CustomerPaymentMethodRequest.put("pay_type","cc");
				payment_methods.add(CustomerPaymentMethodRequest);
				Map<String, Object> CustomerPaymentMethodRequest10 = new HashMap<String, Object>();
					CustomerPaymentMethodRequest10.put("cardholder","Fillius Flitwick");
					CustomerPaymentMethodRequest10.put("expiration","1222");
					CustomerPaymentMethodRequest10.put("number","4000100011112224");
					CustomerPaymentMethodRequest10.put("pay_type","cc");
				payment_methods.add(CustomerPaymentMethodRequest10);
			reqdata.put("payment_methods","payment_methods");
				List<Map> billing_schedules11 = new ArrayList<Map>();
				Map<String, Object> CustomerScheduleRequest = new HashMap<String, Object>();
					CustomerScheduleRequest.put("amount","8");
					CustomerScheduleRequest.put("enabled","1");
						List<Map> rules12 = new ArrayList<Map>();
						Map<String, Object> CustomerRuleRequest = new HashMap<String, Object>();
							CustomerRuleRequest.put("day_offset","3");
							CustomerRuleRequest.put("subject","Day");
						rules.add(CustomerRuleRequest);
						Map<String, Object> CustomerRuleRequest13 = new HashMap<String, Object>();
							CustomerRuleRequest13.put("day_offset","3");
							CustomerRuleRequest13.put("subject","Day");
						rules.add(CustomerRuleRequest13);
					CustomerScheduleRequest.put("rules","rules");
				billing_schedules.add(CustomerScheduleRequest);
				Map<String, Object> CustomerScheduleRequest14 = new HashMap<String, Object>();
					CustomerScheduleRequest14.put("amount","8");
					CustomerScheduleRequest14.put("enabled","1");
						List<Map> rules15 = new ArrayList<Map>();
						Map<String, Object> CustomerRuleRequest16 = new HashMap<String, Object>();
							CustomerRuleRequest16.put("day_offset","3");
							CustomerRuleRequest16.put("subject","Day");
						rules.add(CustomerRuleRequest16);
						Map<String, Object> CustomerRuleRequest17 = new HashMap<String, Object>();
							CustomerRuleRequest17.put("day_offset","3");
							CustomerRuleRequest17.put("subject","Day");
						rules.add(CustomerRuleRequest17);
					CustomerScheduleRequest14.put("rules","rules");
				billing_schedules.add(CustomerScheduleRequest14);
			reqdata.put("billing_schedules","billing_schedules");
		String response = "";
		response = usaepay.Customers.post(reqdata);

		assertEquals("Response did not match ",encoded_response,response);
		assertEquals("Request did not match ",API.json_encode(reqdata),MockHandler.request);
		assertTrue("Path not formatted correctly "+MockHandler.path,MockHandler.path.contains("https://secure.usaepay.com/api/v2/customers"));
		assertEquals("Method did not match ","POST",MockHandler.method.toUpperCase());
	}
}